import random
import string

from django.contrib.auth.models import User
from django.test import TestCase

from locolanderweb import Project


class LocoLanderFactory(object):

    letterdigits = string.letters + string.digits

    def make_random_string(self, size=6, prefix=None):
        result = ''.join(random.choice(self.letterdigits)
                         for x in xrange(size))
        if prefix is not None:
            result = prefix + '-' + result
        return result

    def make_user(self, username=None, password='test', email=None):
        if username is None:
            username = self.make_random_string(prefix='user')
        return User.objects.create(
            username=username, password=password, email=email)


class ProjectTestCase(TestCase):

    factory = LocoLanderFactory()

    def setUp(self):
        super(ProjectTestCase, self).setUp()
        self.user = self.factory.make_user()
        self.obj = Project.objects.create(owner=self.user)

    def test_owner(self):
        self.assertEqual(self.obj.owner, self.user)
